#

package Uploader::CMS;

use strict;

sub plugin {
    MT->component('Uploader');
}

sub _permission_check {
    my $app = MT->instance;
    my $user = $app->user || return 0;
    return 1 if $user->is_superuser;
    my $perms = $app->user->blog_perm($app->param('blog_id')) || return 0;
    return ( $perms->can_administer_blog || $perms->can_uploader );
}

sub redirect {
    my ($app, $mode) = @_;
    
    return $app->error($app->translate('Permission denied.'))
        unless _permission_check();

    my $q = $app->param();
    my $blog_id = scalar $q->param('blog_id');
    
    my $base = $app->app_path . 'plugins/Uploader/uploader.cgi';

    return $app->redirect($base . $app->uri_params(mode => $mode, args => { blog_id => $blog_id }));
}

sub download {
    return redirect(shift, 'download');
}

sub transfer {
    return redirect(shift, 'conftransfer');
}

1;
